package io.skore.smooch_plugin_example

import android.content.Intent
import android.os.Bundle
import android.util.Log
import io.flutter.app.FlutterActivity
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugins.GeneratedPluginRegistrant

class MainActivity : FlutterActivity() {
    private val tag = MainActivity::class.java.simpleName
    private val channelName = "app_state"

    override fun onCreate(savedInstanceState: Bundle?) {
        Log.d(tag, "onCreate")
        super.onCreate(savedInstanceState)

        GeneratedPluginRegistrant.registerWith(this)
        setupMethodChannel()
    }

    override fun onNewIntent(intent: Intent?) {
        Log.d(tag, "onNewIntent")
        super.onNewIntent(intent)
    }

    private fun setupMethodChannel() {
        MethodChannel(flutterView, channelName).setMethodCallHandler { call, result ->
            when (call.method) {
                "getStartAction" -> {
                    val action = intent?.action ?: "unknown"
                    val scheme = intent?.scheme ?: "unknown"
                    val host = intent?.data?.host ?: "unknown"
                    Log.d(tag, "initState() => action: $action scheme: $scheme host: $host")
                    result.success(action)
                }
                else -> result.notImplemented()
            }
        }
    }
}
